"use strict";
var ngast_1 = require("ngast");
var fs_1 = require("fs");
var projectSymbols = undefined;
var lastProgram;
var contexts;
exports.parseTemplate = function (declaration, fileName, program) {
    if (!projectSymbols || lastProgram !== program) {
        projectSymbols = new ngast_1.ProjectSymbols({
            create: function () {
                return program;
            }
        }, {
            get: function (path) {
                return Promise.resolve(null);
            },
            getSync: function (path) {
                return fs_1.readFileSync(path, { encoding: 'utf-8' });
            }
        });
        contexts = projectSymbols.getLazyLoadedContexts().concat(projectSymbols.getRootContext());
    }
    var directive;
    for (var i = 0; i < contexts.length && !directive; i += 1) {
        directive = contexts[i].getDirectiveFromNode(declaration, fileName);
    }
    if (directive) {
        return directive.getTemplateAst().templateAst;
    }
    else {
        return undefined;
    }
};
